;	================================================================================
							.Code
;	================================================================================

							ALIGN	4

;	================================================================================

ThreadRootFoldersProc		PROC	USES EBX EDI ESI,__lpTvFolders:Ptr TV_FOLDERS
							LOCAL	_TVis:TV_INSERTSTRUCT
							LOCAL	_Wf:WIN32_FIND_DATA
							LOCAL	_szOldDirectory[LEN_FILENAME + 1]:Byte
							LOCAL	_hFound:HANDLE
							LOCAL	_hParent:HTREEITEM
							LOCAL	_lpszFoundFileName:LPSTR
							LOCAL	_lpTVis:Ptr TV_INSERTSTRUCT
							LOCAL	_lpWf:Ptr WIN32_FIND_DATA
							LOCAL	_lpszThreadDirectoryName:LPSTR

							mov		dwListActiv,FALSE

							INVOKE	ShowWindow,hComboPages,SW_HIDE

							mov		esi,__lpTvFolders

							lea		eax,(TV_FOLDERS Ptr [esi]).szThreadDirectoryName
							lea		edx,_TVis
							lea		ecx,_Wf.cFileName
							lea		ebx,_Wf

							mov		_lpszThreadDirectoryName,eax
							mov		_lpszFoundFileName,ecx
							mov		eax,(TV_FOLDERS Ptr [esi]).hParent
							mov		_lpTVis,edx
							mov		_TVis.itemex.pszText,ecx
							mov		_lpWf,ebx

							mov		_hParent,eax
							mov		_TVis.hParent,eax
							mov		_TVis.hInsertAfter,TVI_SORT
							mov		_TVis.itemex.imask,TVIF_DI_SETITEM or TVIF_PARAM or TVIF_TEXT or TVIF_IMAGE or TVIF_SELECTEDIMAGE
							mov		_TVis.itemex.cChildren,1
							mov		_TVis.itemex.iImage,5
							mov		_TVis.itemex.iSelectedImage,4

							INVOKE	GetCurrentDirectory,LEN_FILENAME + 1,ADDR _szOldDirectory
							INVOKE	SetCurrentDirectory,_lpszThreadDirectoryName

							test	eax,eax
							jz		@Exit

								INVOKE	FindFirstFile,ADDR szAllFiles,_lpWf

								cmp		eax,INVALID_HANDLE_VALUE
								je		@Exit

									mov		_hFound,eax
									jmp		@Next_1

@Next :

							INVOKE	FindNextFile,_hFound,_lpWf

							test	eax,eax
							jz		@EndLoop

@Next_1 :

							cmp		Byte Ptr _Wf.cFileName,'.'
							je		@Next

							test	_Wf.dwFileAttributes,FILE_ATTRIBUTE_DIRECTORY
							jz		@Next

							INVOKE	M_Alloc,SIZEOF TV_FOLDERS

							test	eax,eax
							jz		@Exit

							mov		_TVis.itemex.lParam,eax
							mov		edi,eax

							mov		eax,_hParent
							mov		(TV_FOLDERS Ptr [edi]).hParent,eax

							INVOKE	lstrcpy,ADDR (TV_FOLDERS Ptr [edi]).szDirectoryName,_lpszFoundFileName				; Short Name
							INVOKE	lstrcpy,ADDR (TV_FOLDERS Ptr [edi]).szThreadDirectoryName,_lpszThreadDirectoryName	; Long Name
							INVOKE	PathAddBackslash,eax
							INVOKE	lstrcat,eax,_lpszFoundFileName

							INVOKE	SendMessage,hTreeView,TVM_INSERTITEM,0,_lpTVis

							push	eax
							mov		(TV_FOLDERS Ptr [edi]).hItem,eax

							mov		eax,lpFirstDirectory
							mov		(LINKEDLIST Ptr [eax]).lpNext,edi
							mov		(TV_FOLDERS Ptr [edi]).List.lpPrev,eax
							mov		lpFirstDirectory,edi
							mov		(LINKEDLIST Ptr [edi]).lpPtr,edi
							pop		eax

							test	eax,eax
							jnz		@Next

@EndLoop :

							INVOKE	FindClose,_hFound

							INVOKE	SetCurrentDirectory,ADDR _szOldDirectory
							INVOKE	SendMessage,hTreeView,TVM_EXPAND,TVE_EXPAND,_hParent

@Exit :

							ret
ThreadRootFoldersProc		ENDP

;	================================================================================

CreateTreeView				PROC
							LOCAL	_rc:RECT

							INVOKE	GetClientRect,esi,ADDR _rc

							push	NULL
							push	DWord Ptr hInstance
							push	1959h
							push	esi							; Parent
							push	DWord Ptr _rc.bottom		; H
							push	DWord Ptr _rc.right			; W
							push	0							; Y
							push	0							; X
							push	WS_HSCROLL or WS_BORDER or WS_CHILD or WS_VISIBLE or TVS_HASLINES or TVS_HASBUTTONS or TVS_LINESATROOT or TVS_EDITLABELS or TVS_FULLROWSELECT or TVS_INFOTIP or TVS_SHOWSELALWAYS or WS_CLIPSIBLINGS
							push	OFFSET szNullString
							push	OFFSET szTreeClass
							push	WS_EX_CLIENTEDGE
							call	CreateWindowEx

							mov		DWord Ptr hTreeView,eax 

							INVOKE	SendMessage,eax,WM_SETFONT,hMainFont,TRUE					;	EAX = hTreeView

							INVOKE	SendMessage,hTreeView,TVM_SETBKCOLOR,0,00dcedceh			;	206(CE),37(ED),220(DC)
							INVOKE	SendMessage,hTreeView,TVM_SETTEXTCOLOR,0,0					;	00ffffe0h
							INVOKE	SendMessage,hTreeView,TVM_SETLINECOLOR,0,00ff00ffh			;	00ffffe0h
							INVOKE	SendMessage,hTreeView,TVM_SETINSERTMARKCOLOR,0,00ffffe0h

							INVOKE	ImageList_Create,16,16,ILC_COLOR32,10,10

							mov		DWord Ptr hImageList,eax
							push	eax

							INVOKE	LoadBitmap,hInstance,IDB_TOOLBAR

							push	eax

							INVOKE	ImageList_Add,hImageList,eax,NULL

							call	DeleteObject

							push	0
							push	TVM_SETIMAGELIST
							push	DWord Ptr hTreeView
							call	SendMessage

@Exit :

							ret
CreateTreeView				ENDP

;	================================================================================

Folders_WmCreate			PROC	USES EBX EDI ESI
							LOCAL	_TVis:TV_INSERTSTRUCT
							LOCAL	_hParent:HTREEITEM
							LOCAL	_hComputer:HTREEITEM
							LOCAL	_dwDrive:DWord
							LOCAL	_dwTmp:DWord
							LOCAL	_szTmp[512]:Byte

							call	CreateTreeView

							INVOKE	SHGetSpecialFolderPath,NULL,ADDR szDesktop,CSIDL_DESKTOPDIRECTORY,FALSE
							INVOKE	SHGetSpecialFolderPath,NULL,ADDR szMyDocuments,CSIDL_PERSONAL,FALSE
							INVOKE	SHGetSpecialFolderPath,NULL,ADDR szMyImages,CSIDL_MYPICTURES,FALSE
							INVOKE	SHGetSpecialFolderPath,NULL,ADDR szMyMusique,CSIDL_MYMUSIC,FALSE
							INVOKE	SHGetSpecialFolderPath,NULL,ADDR szMyVideos,CSIDL_MYVIDEO,FALSE

;	**************
;	*** Bureau ***
;	**************

							INVOKE	M_Alloc,SIZEOF TV_FOLDERS

							mov		edi,eax
							mov		lpBureau,eax
							mov		lpFirstDirectory,eax

							mov		_TVis.itemex.lParam,eax

							INVOKE	lstrcpy,ADDR (TV_FOLDERS Ptr [edi]).szDirectoryName,ADDR szBureau
							INVOKE	lstrcpy,ADDR (TV_FOLDERS Ptr [edi]).szThreadDirectoryName,ADDR szDesktop

							mov		_TVis.hParent,TVI_ROOT
							mov		_TVis.hInsertAfter,TVI_FIRST
							mov		_TVis.itemex.imask,TVIF_DI_SETITEM or TVIF_PARAM or TVIF_TEXT or TVIF_IMAGE or TVIF_SELECTEDIMAGE
							mov		_TVis.itemex.pszText,OFFSET szBureau
							mov		_TVis.itemex.cChildren,1
							mov		_TVis.itemex.iImage,0
							mov		_TVis.itemex.iSelectedImage,0

							INVOKE	SendMessage,hTreeView,TVM_INSERTITEM,0,ADDR _TVis

							mov		(TV_FOLDERS Ptr [edi]).hItem,eax

							mov		_hParent,eax
							mov		_TVis.hParent,eax

							mov		hDeskTop,eax

;	************************
;	*** Poste de Travail ***
;	************************

							INVOKE	M_Alloc,SIZEOF TV_FOLDERS

							mov		edi,eax
							mov		lpPosteDeTravail,eax

							mov		_TVis.itemex.lParam,eax
							mov 	(TV_FOLDERS Ptr [eax]).szDirectoryName,-1

							mov		edx,_hParent
							mov		(TV_FOLDERS Ptr [eax]).hParent,edx

							mov		_TVis.hInsertAfter,TVI_SORT
							mov		_TVis.itemex.pszText,OFFSET szPosteDeTravail
							mov		_TVis.itemex.iImage,17
							mov		_TVis.itemex.iSelectedImage,17

							mov		_TVis.itemex.lParam,OFFSET szMyComputer

							INVOKE	SendMessage,hTreeView,TVM_INSERTITEM,0,ADDR _TVis

							mov		(TV_FOLDERS Ptr [edi]).hItem,eax

							mov		_hComputer,eax
							mov		hPosteDeTravail,eax

;	*********************
;	*** Mes Documents ***
;	*********************

							INVOKE	M_Alloc,SIZEOF TV_FOLDERS

							mov		edi,eax
							mov		lpMesDocuments,eax

							mov		_TVis.itemex.lParam,eax

							mov		edx,_hComputer
							mov		(TV_FOLDERS Ptr [edi]).hParent,edx

							INVOKE	lstrcpy,ADDR (TV_FOLDERS Ptr [edi]).szDirectoryName,ADDR szMesDocuments
							INVOKE	lstrcpy,ADDR (TV_FOLDERS Ptr [edi]).szThreadDirectoryName,ADDR szMyDocuments

							mov		_TVis.itemex.pszText,OFFSET szMesDocuments
							mov		_TVis.itemex.iImage,20
							mov		_TVis.itemex.iSelectedImage,20

							INVOKE	SendMessage,hTreeView,TVM_INSERTITEM,0,ADDR _TVis

							mov		(TV_FOLDERS Ptr [edi]).hItem,eax

;	******************
;	*** Ma Musique ***
;	******************

							INVOKE	M_Alloc,SIZEOF TV_FOLDERS

							mov		edi,eax
							mov		lpMaMusique,eax

							mov		_TVis.itemex.lParam,eax

							mov		edx,_hComputer
							mov		(TV_FOLDERS Ptr [edi]).hParent,edx

							INVOKE	lstrcpy,ADDR (TV_FOLDERS Ptr [edi]).szDirectoryName,ADDR szMaMusique
							INVOKE	lstrcpy,ADDR (TV_FOLDERS Ptr [edi]).szThreadDirectoryName,ADDR szMyMusique

							mov		_TVis.itemex.pszText,OFFSET szMaMusique
							mov		_TVis.itemex.iImage,19
							mov		_TVis.itemex.iSelectedImage,19

							INVOKE	SendMessage,hTreeView,TVM_INSERTITEM,0,ADDR _TVis

							mov		(TV_FOLDERS Ptr [edi]).hItem,eax

;	******************
;	*** Mes Images ***
;	******************

							INVOKE	M_Alloc,SIZEOF TV_FOLDERS

							mov		edi,eax
							mov		edx,_hComputer
							mov		_TVis.itemex.lParam,eax
							mov		(TV_FOLDERS Ptr [edi]).hParent,edx
							mov		lpMesImages,eax

							INVOKE	lstrcpy,ADDR (TV_FOLDERS Ptr [edi]).szDirectoryName,ADDR szMesImages
							INVOKE	lstrcpy,ADDR (TV_FOLDERS Ptr [edi]).szThreadDirectoryName,ADDR szMyImages

							mov		_TVis.itemex.pszText,OFFSET szMesImages
							mov		_TVis.itemex.iImage,21
							mov		_TVis.itemex.iSelectedImage,21

							INVOKE	SendMessage,hTreeView,TVM_INSERTITEM,0,ADDR _TVis

							mov		(TV_FOLDERS Ptr [edi]).hItem,eax

;	******************
;	*** Mes Vidos ***
;	******************

							INVOKE	M_Alloc,SIZEOF TV_FOLDERS

							mov		edi,eax
							mov		edx,_hComputer
							mov		_TVis.itemex.lParam,eax
							mov		(TV_FOLDERS Ptr [edi]).hParent,edx
							mov		lpMesVideos,eax

							INVOKE	lstrcpy,ADDR (TV_FOLDERS Ptr [edi]).szDirectoryName,ADDR szMesVideos
							INVOKE	lstrcpy,ADDR (TV_FOLDERS Ptr [edi]).szThreadDirectoryName,ADDR szMyVideos

							mov		_TVis.itemex.pszText,OFFSET szMesVideos
							mov		_TVis.itemex.iImage,15
							mov		_TVis.itemex.iSelectedImage,15

							INVOKE	SendMessage,hTreeView,TVM_INSERTITEM,0,ADDR _TVis

							mov		(TV_FOLDERS Ptr [edi]).hItem,eax

;	***************************
;	*** Ajouter les disques ***
;	***************************

							INVOKE	SetErrorMode,SEM_FAILCRITICALERRORS

							lea		eax,_szTmp

							mov		_TVis.hInsertAfter,TVI_SORT
							mov		_TVis.itemex.pszText,eax
							mov		_TVis.itemex.imask,TVIF_DI_SETITEM or TVIF_PARAM or TVIF_TEXT or TVIF_IMAGE or TVIF_SELECTEDIMAGE
							mov		eax,_hComputer
							mov		_TVis.itemex.state,0
							mov		_TVis.itemex.iIntegral,0
							mov		_TVis.hParent,eax
							mov		_TVis.itemex.cChildren,1

							call	GetLogicalDrives

							mov		ecx,eax

							mov		ebx,'A' - 1

@@ :

							test	ecx,ecx
							jz		NoDrive

							mov		eax,ecx

							shr		ecx,1

							push	ecx
							push	ebx

							and		eax,00000001b
							jz		@Next

							add		eax,ebx
							mov		_dwDrive,eax

							INVOKE	wsprintf,_TVis.itemex.pszText,ADDR szFmt_0002,eax

							mov		_TVis.itemex.cchTextMax,eax

							INVOKE	GetDriveType,_TVis.itemex.pszText

							mov		_dwTmp,eax

							xor		edx,edx
							mov		ecx,1

							cmp		eax,DRIVE_UNKNOWN
							cmove	edx,ecx

							mov		ecx,12

							cmp		eax,DRIVE_REMOVABLE				; 12
							cmove	edx,ecx

							mov		ecx,8

							cmp		eax,DRIVE_FIXED					; 8
							cmove	edx,ecx

							mov		ecx,33

							cmp		eax,DRIVE_REMOTE				; 33
							cmove	edx,ecx

							mov		ecx,10

							cmp		eax,DRIVE_CDROM					; 10
							cmove	edx,ecx

							mov		ecx,12

							cmp		eax,DRIVE_RAMDISK				; 12
							cmove	edx,ecx

							mov		_TVis.itemex.iImage,edx
							mov		_TVis.itemex.iSelectedImage,edx

							INVOKE	M_Alloc,SIZEOF TV_FOLDERS

							test	eax,eax
							jz		@Next

							mov		edi,eax
							mov		_TVis.itemex.lParam,eax

							INVOKE	lstrcpy,ADDR (TV_FOLDERS Ptr [edi]).szDirectoryName,_TVis.itemex.pszText
							INVOKE	lstrcpy,ADDR (TV_FOLDERS Ptr [edi]).szThreadDirectoryName,_TVis.itemex.pszText

							mov		eax,_hComputer
							mov		(TV_FOLDERS Ptr [edi]).hParent,eax

							INVOKE	SendMessage,hTreeView,TVM_INSERTITEM,0,ADDR _TVis

							mov		(TV_FOLDERS Ptr [edi]).hItem,eax
							mov		edx,DWord Ptr _dwDrive

@Next :

							pop		ebx
							pop		ecx

							add		ebx,1
							jmp		@B

NoDrive :

							INVOKE	SendMessage,hTreeView,TVM_EXPAND,TVE_EXPAND,_hParent
							INVOKE	SendMessage,hTreeView,TVM_EXPAND,TVE_EXPAND,_hComputer

@Exit :

							ret
Folders_WmCreate			ENDP

;	================================================================================

Folders_WmClose :

							push	edi
							push	esi

							mov		esi,lpBureau

							test	esi,esi
							jz		Folders_WmClose_EndLoop

Folders_WmClose_Loop :

								mov		edi,(LINKEDLIST Ptr [esi]).lpNext

								INVOKE	M_Free,esi

								test	edi,edi
								jz		Folders_WmClose_EndLoop

									mov		esi,edi
									jmp		Folders_WmClose_Loop

Folders_WmClose_EndLoop :

							INVOKE	M_Free,lpBureau
							INVOKE	M_Free,lpPosteDeTravail
							INVOKE	M_Free,lpMesDocuments
							INVOKE	M_Free,lpMesImages
							INVOKE	M_Free,lpMaMusique
							INVOKE	M_Free,lpMesVideos

							pop		esi
							pop		edi
							ret

;	================================================================================

;	*************************************
;	*** Afficher le contenu du Bureau ***
;	*************************************

ShowDeskTop					PROC	__hItem:HTREEITEM,__lpTVFolder:PTR TV_FOLDERS
							LOCAL	_dwCount:DWord

							mov		_dwCount,0

							INVOKE	SendMessage,hTreeView,TVM_GETNEXTITEM,TVGN_CHILD,__hItem

							test	eax,eax
							jz		@Exit

							add		_dwCount,1

@Loop :

							INVOKE	SendMessage,hTreeView,TVM_GETNEXTITEM,TVGN_NEXT,eax

								test	eax,eax
								jz		@EndLoop

									add		_dwCount,1
									jmp		@Loop

@EndLoop :

							cmp		_dwCount,5
							jg		@Exit

								mov		eax,__lpTVFolder
								mov		edx,__hItem

								mov		(TV_FOLDERS PTR [eax]).hParent,edx

								INVOKE	CreateThread,NULL,NULL,ADDR ThreadRootFoldersProc,eax,0,NULL
								INVOKE	CloseHandle,eax

@Exit :

							ret
ShowDeskTop					ENDP

;	================================================================================

;	*************************************
;	*** Afficher la liste des disques ***
;	*************************************

ShowComputer				PROC	__lpTVFolder:PTR TV_FOLDER

							mov		eax,__lpTVFolder

							ret
ShowComputer				ENDP

;	================================================================================

SearchSpecialChildren		PROC	__hItem:HTREEITEM,__lpTVFolder:PTR TV_FOLDERS

							mov		eax,__lpTVFolder
							mov		edx,__hItem

							mov		(TV_FOLDERS PTR [eax]).hParent,edx

							INVOKE	CreateThread,NULL,NULL,ADDR ThreadRootFoldersProc,eax,0,NULL
							INVOKE	CloseHandle,eax

							ret
SearchSpecialChildren		ENDP

;	================================================================================

SearchRootChildren			PROC	__hItem:HTREEITEM,__lpTVFolder:PTR TV_FOLDERS

							mov		edx,__hItem
							mov		eax,__lpTVFolder

							mov		(TV_FOLDERS PTR [eax]).hParent,edx

							INVOKE	CreateThread,NULL,NULL,ADDR ThreadRootFoldersProc,eax,0,NULL
							INVOKE	CloseHandle,eax

							ret
SearchRootChildren			ENDP

;	================================================================================

SearchNormalChildren		PROC	__hItem:HTREEITEM,__lpTVFolder:PTR TV_FOLDERS

							mov		edx,__hItem
							mov		eax,__lpTVFolder

							mov		(TV_FOLDERS PTR [eax]).hParent,edx

							INVOKE	CreateThread,NULL,NULL,ADDR ThreadRootFoldersProc,eax,0,NULL
							INVOKE	CloseHandle,eax

							ret
SearchNormalChildren		ENDP

;	================================================================================

;	*************************************
;	*** Rechercher l'item slectionn ***
;	*************************************

SearchIntoThisDirectory		PROC	__hItem:HTREEITEM,__lpTVFolder:PTR TV_FOLDERS
							LOCAL	_hParent:HTREEITEM

							mov		eax,__hItem

							cmp		eax,hPosteDeTravail				; On est sur la liste des disques
							je		@PosteDeTravail

								cmp		eax,hDeskTop					; On est sur le bureau
								je		@Bureau

									INVOKE	SendMessage,hTreeView,TVM_GETNEXTITEM,TVGN_PARENT,__hItem

									mov		_hParent,eax

									cmp		eax,hPosteDeTravail				; Parent = Poste de Travail
									je		@DriveDirectory

										cmp		eax,hDeskTop					; Parent = Dossier spcial
										je		@SpecialDirectory

											jmp		@ParentDirectory				; Parent = Dossier

@Bureau :

							push	__lpTVFolder
							push	__hItem
							push	OFFSET @Selected
							jmp		ShowDeskTop

@PosteDeTravail :

							push	__lpTVFolder
							push	OFFSET @Exit
							jmp		ShowComputer

;	*****************************************
;	*** Le parent est le Poste de Travail ***
;	*** Il s'agit donc d'une racine       ***
;	*****************************************

@DriveDirectory :

							INVOKE	SendMessage,hTreeView,TVM_GETNEXTITEM,TVGN_CHILD,__hItem

							test	eax,eax							; Les enfants sont dj affichs
							jnz		@Selected

;	===> Il faut rechercher les dossiers prsents dans cette branche

								push	__lpTVFolder
								push	__hItem
								push	OFFSET @Selected
								jmp		SearchRootChildren				; Le parent est une racine

;	***************************************************
;	*** Le parent est un dossier ou un sous-dossier ***
;	***************************************************

@ParentDirectory :


							INVOKE	SendMessage,hTreeView,TVM_GETNEXTITEM,TVGN_CHILD,__hItem

							test	eax,eax							; Les enfants sont dj affichs
							jnz		@Selected

;	===> Il faut rechercher les dossiers prsents dans cette branche

								push	__lpTVFolder
								push	__hItem
								push	OFFSET @Selected
								jmp		SearchNormalChildren			; Le parent est un dossier

;	**********************************************
;	*** Le parent est le Bureau                ***
;	*** Il peut donc s'agir de "Mes Images"... ***
;	*** Ou d'un dossier normal                 ***
;	**********************************************

@SpecialDirectory :

							INVOKE	SendMessage,hTreeView,TVM_GETNEXTITEM,TVGN_CHILD,__hItem

							test	eax,eax							; Les enfants sont dj affichs
							jnz		@Selected

;	===> Il faut rechercher les dossiers prsents dans cette branche

								push	__lpTVFolder
								push	__hItem
								push	OFFSET @Selected
								jmp		SearchSpecialChildren			; Le parent est un dossier spcial

;	********************************************************************
;	*** Il faut envoyer un message pour mettre  jour les miniatures ***
;	********************************************************************

@Selected :

							INVOKE	SendMessage,hWndMain,WM_IVIEW_FOLDER_SELECTED,__hItem,__lpTVFolder

@Exit :

							ret
SearchIntoThisDirectory		ENDP

;	================================================================================

;	================================================================================

Folders_WmNotify			PROC	USES EBX EDI ESI,__hWnd:HWND,__lpNmHdr:Ptr NMHDR
							LOCAL	_Tvi:TVITEM
							LOCAL	_szTmp[LEN_FILENAME + 1]:Byte

							mov		ebx,__lpNmHdr

							cmp		(NMHDR Ptr [ebx]).code,TVN_SELCHANGED
							jne		@Exit

@SelChanged :

								lea		edx,_szTmp

								mov		eax,(NMTREEVIEW Ptr [ebx]).itemNew.hItem
								mov		_Tvi._mask,TVIF_PARAM or TVIF_TEXT
								mov		_Tvi.hItem,eax
								mov		_Tvi.pszText,edx
								mov		_Tvi.cchTextMax,SIZEOF _szTmp
								mov		_Tvi.lParam,NULL

								INVOKE	SendMessage,hTreeView,TVM_GETITEM,0,ADDR _Tvi

								test	eax,eax
								jz		@Exit

									mov		eax,_Tvi.lParam

									cmp		eax,lpPosteDeTravail
									je		@_PosteDeTravail

										push	eax								; TV_FOLDER
										push	_Tvi.hItem						; hItem
										push	OFFSET @Exit
										jmp		SearchIntoThisDirectory			; SearchIntoThisDirectory(lpszItem,hItem,lpTVFolder) ;

@_PosteDeTravail :

							jmp		@Exit

@Exit :

							mov		eax,TRUE

							ret
Folders_WmNotify			ENDP

;	================================================================================

FoldersWndProc				PROC	USES EBX EDI ESI,hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

							mov		esi,DWord Ptr hWnd
							mov		edi,DWord Ptr lParam
							mov		ebx,DWord Ptr wParam
							mov		eax,DWord Ptr uMsg

							cmp		eax,WM_CREATE
							jne		@F

								push	OFFSET @End
								jmp		Folders_WmCreate

@@ :

							cmp		eax,WM_CLOSE
							jne		@F

								push	OFFSET @End
								jmp		Folders_WmClose

@@ :

							cmp		eax,WM_SIZE
							jne		@F

								mov		eax,edi
								and		eax,0000ffffh
								shr		edi,16

								push	TRUE
								push	edi
								push	eax
								push	0
								push	0
								push	hTreeView
								push	OFFSET @Exit
								jmp		MoveWindow

@@ :

							cmp		eax,WM_NOTIFY
							jne		@F

								push	edi					; LPNMHDR
								push	esi
								push	OFFSET @Exit
								jmp		Folders_WmNotify

@@ :

							push	edi
							push	ebx
							push	eax
							push	esi
							push	OFFSET @End
							jmp		DefWindowProc							

@Exit :

							xor		eax,eax

@End :

							ret
FoldersWndProc				ENDP

;	================================================================================

Folders_Create :

							INVOKE	CreateWindowEx,WS_EX_CLIENTEDGE or WS_EX_WINDOWEDGE or WS_EX_STATICEDGE or WS_EX_TOOLWINDOW,\
									ADDR szFoldersClass,ADDR szNullString,WS_CHILD or WS_VISIBLE,\
									0,0,rcFolders.right,rcFolders.bottom,\
									esi,NULL,hInstance,NULL

							ret

;	================================================================================
